import string
import math
##import pylab
from numpy import log, exp, sqrt, take, hstack, vstack, ones, zeros, empty,\
argmax, argmin, arange, linspace, array, dot, average, std
import numpy
##from numpy import *
##from matplotlib.axes3d import *

VERBOSE=0

def showpoints(xs,ys,zs):
    ##xs,ys,zs=mat_reverse(points[:])
    fig = pylab.figure()
    ax = Axes3D(fig)
    ax.scatter3D(xs,ys,zs, c='r')
    ##ax.set_xlabel('X Label')
    ##ax.set_ylabel('Y Label')
    ##ax.set_zlabel('Z Label')
    fig.add_axes(ax)
    #p.show()

def distMetricTup(u,v,S=None):
    if S==None:S=ones(len(u))
    U=array(u)
    V=array(v)
    return math.sqrt(dot((U-V)/S,(U-V)/S))

def idx(x):
   return x

def allwaysTrue(v):
   return True

def georange(n,m,r):
   s=[n]
   k=n
   while k<m:
      k=k*r
      s.append(k)
   return s

def save_dba2(dba,filnavn):
  ##from pickle import dump
  from cPickle import dump
  fil=open(filnavn,'w')
  dump(dba,fil)
  fil.close()

def save_dba(dba):
  ##from pickle import dump
  from cPickle import dump
  filnavn=raw_input('indtast filnavn ')
  fil=open(filnavn,'w')
  dump(dba,fil)
  fil.close()

def read_dba(filnavn):
  ##from pickle import load
  from cPickle import load
  fil=open(filnavn,'r')
  dba=load(fil)
  return dba
   
def distMetric3(u,v,s):
   U=numpy.array(u)
   V=numpy.array(v)
   S=numpy.array(s)
   return math.sqrt(numpy.dot((U-V)/S,(U-V)/S))

def indexSort(s):
  t=[]
  for p in s:t.append((p.index,p))
  t.sort()
  u=[]
  for p2 in t:u.append(p2[1])
  return u

def erf(x):
    p=0.47047
    a=[0.3480242,-0.0958798,0.7478556]
    t=1.0/(1+p*x)
    sum=0.0
    for i in range(1,4):
	sum=sum+a[i-1]*t**i
    return 1.0-sum*math.exp(-x**2)

def comStandardNormal(x):
    if x>0:return 0.5*(1.0+erf(x/math.sqrt(2)))
    elif x>=-0.000001:return 0.5
    else:return 1.0-comStandardNormal(-x)

#for i in range(8):
#    print i,math.log(comStandardNormal(-i)),1-2*comStandardNormal(-i)

#print erf(0)


def calc_mean_and_stdd(X):
  antal=len(X)
  if antal==0: return 0.0, 1.0
  if antal==1: return X[0],0.0
  sx=0.0
  sx2=0.0
  for i in range(antal):
     try:
        sx=sx+X[i]
     except TypeError: print X
     sx2=sx2+pow(X[i],2)
  if antal==1: return sx, sx
  sdsum=0.0
  m=sx/antal
  for i in range(antal):
      sdsum=sdsum+abs(1.0*X[i]-m)
  return m, sdsum/antal

def asort2(mat,indexes):
  si=indexes[:]
  si.sort()
  for j in range(len(mat)):
     temp=mat[j][:]
     for k in range(len(si)-1,-1,-1): #baglaens index efter prioritet
        del mat[j][si[k]]
     frontlist=[]
     for i in indexes:
        frontlist.append(temp[i])
     mat[j]=frontlist+mat[j]
  #mat er nu i rette format til at sortere
  mat.sort()
  for j in range(len(mat)):
     temp=mat[j][:]
     mat[j]=mat[j][len(si):]
     for k in range(len(si)): #forleans
        newindex=indexes.index(si[k]) #index efter prioritet
        newelem=temp[newindex]
        mat[j]=mat[j][:si[k]]+[newelem]+mat[j][si[k]:]

def initializer(filename):
  maininp=open(filename, 'r')
  input=maininp.readlines() #giver en liste m. linierne som elementerne
  for i in range(len(input)):
     input[i]=input[i][:-1] #fjerner tegn for linieskift
  for i in range(len(input)-1,-1,-1):
     if input[i][0]=='!': del input[i] # tegnet ! kan bruges til kommentarer
     else:
	for j in range(len(input[i])):
	   if input[i][j]=='!':
	      input[i]=input[i][:j]#alle tegn paa en linie indtil '!'
	      break
  #for x in input: print x
  return input

def initfil(filename):
  if filename==None: return []
  file=open(filename,'r')
  buffer=file.readlines()
  file.close()
  return buffer

def initfil2(filename):
  file=open(filename,'r')
  buffer=file.readlines()
  file.close()
  for i in range(len(buffer)):
     buffer[i]=string.split(buffer[i])
  return buffer

def initfil2f(filename):
  file=open(filename,'r')
  buffer=file.readlines()
  file.close()
  for i in range(len(buffer)):
     buffer[i]=string.split(buffer[i])
     buffer[i]=[eval(buffer[i][j]) for j in range(len(buffer[i]))]
  return buffer

def initfil3(filename):
  if filename==None: return []
  file=open(filename,'r')
  buffer=file.readlines()
  file.close()
  for i in range(len(buffer)):
     buffer[i]=buffer[i][:-1] #fjerner tegn for linieskift
  return buffer

##def save_dba2(dba,filnavn):
##  from pickle import dump
##  fil=open(filnavn,'w')
##  dump(dba,fil)
##  fil.close()
##
##def save_dba(dba):
##  filnavn=raw_input('indtast filnavn ')
##  from pickle import dump
##  fil=open(filnavn,'w')
##  dump(dba,fil)
##  fil.close()
##
##def read_dba(filnavn):
##  fil=open(filnavn,'r')
##  from pickle import load
##  dba=load(fil)
##  return dba

def initfil_floatmat(filename):
  file=open(filename,'r')
  buffer=file.readlines()
  for lin in range(len(buffer)):
     buffer[lin]=string.split(buffer[lin])
     for i in range(len(buffer[lin])):
	buffer[lin][i]=string.atof(buffer[lin][i])
  return buffer

def copy_2dbuffer(buffer):
  newbuffer=buffer[:]
  buf0=newbuffer[0][:]
  buf1=newbuffer[1][:]#vollst
  buf2=newbuffer[2][:]#scolst
  if buf1<>[]:
     newbuf1=buf1[:]
     buf1=[]
     for i in range(len(newbuf1)):
	buf1.append(newbuf1[i][:])
  if buf2<>[]:
     newbuf2=buf2[:]
     buf2=[]
     for i in range(len(newbuf2)):
	buf2.append(newbuf2[i][:])	
  return [buf0,buf1,buf2]

def print_histogram(liste,mean,stdd): #liste skal vare sorteret
  bredde=(liste[0]+liste[-1])
  tal=mean-0.25*stdd
  while tal >= liste[0]:
     tal=tal-0.25*stdd
     counter=0
     countergl=counter
  # starten af datasaettet er naaet
  while tal <= liste[-1]:
     tal=tal+0.25*stdd
     countergl=counter
     while liste[counter]<tal and counter<>len(liste)-1: counter=counter+1
     print (counter-countergl)*'*', round(tal-0.125*stdd,6) #soejlen i histogrammet

def del_value2(s,val):
  dellist=[]
  for i in range(len(s)):
     if s[i]==val:
	dellist.append(i)
  dellist.reverse()
  for i in dellist:
     del s[i]

def Q_strip_from_top(s): # s skal vaere sorteret
  width=s[-1]-s[0]
  length=len(s)
  if length<=2: return s,[]
  jump=width/math.sqrt(length)
  i=1
  while i<=length/2:
     if s[-i]-s[-i-1]>i*jump:
	return s[:-i], s[length-i:]
     i=i+1
  return s,[] #ingen outlyer er fundet

def Q_strip_from_bottom(s): # s skal vaere sorteret
  width=s[-1]-s[0]
  length=len(s)
  if length<=2: return s,[]
  jump=width/math.sqrt(length)
  i=1
  while i<=length/2:
     if s[i]-s[0]>i*jump:
	return s[i:], s[:i]
     i=i+1
  return s,[] #ingen outlyer er fundet

def combRek(outlst,lst):
   ##print outlst,lst
   newoutlst=[]
   for s in outlst:
        for i in lst[0]:
	    newoutlst.append(s+[i])
   if len(lst)==1:
        return newoutlst
   else:return combRek(newoutlst,lst[1:])

def combRekStr(outlst,lst):
   ##print outlst,lst
   newoutlst=[]
   for s in outlst:
        for si in lst[0]:
	    newoutlst.append(s+si)
   if len(lst)==1:
        return newoutlst
   else:return combRekStr(newoutlst,lst[1:])

def combRek2(outlst,lst):
   ##print outlst,lst
   newoutlst=[]
   for s in outlst:
        for i in lst[0]:
	  Bool=0
	  for k in s:
	    if k==i:Bool=1;break
          if not Bool:
	    newoutlst.append(s+[i])
   if len(lst)==1:
        return newoutlst
   else:return combRek2(newoutlst,lst[1:])

def comb(lst):
   if len(lst)==1:return lst
   else:
	outlst=[]
	for x in lst[0]:outlst.append([x])
	return combRek(outlst,lst[1:])


def combStr(lst):
   if len(lst)==1:return lst
   else:
	outlst=[]
	for x in lst[0]:outlst.append(x)
	return combRekStr(outlst,lst[1:])

def comb2(lst):
   if len(lst)==1:return lst
   else:
	outlst=[]
	for x in lst[0]:outlst.append([x])
	return combRek2(outlst,lst[1:])

def comb3(lst):
   lst2=comb2([lst,lst[:]])
   for i in range(len(lst2)-1,-1,-1):
	x=lst2[i]
	if x[0]>=x[1]:del lst2[i]
   return lst2

def comb4(n):
   return comb3(range(n))

def make_qdba(lst):
#douplets are put in regular boxes according to their
#coordinates
  xmin=10.0
  xmax=0.0
  ymin=10.0
  ymax=0.0
  for i in range(len(lst)):
     x=lst[i][0]
     y=lst[i][1]
     if x>xmax:xmax=x
     if x<xmin:xmin=x
     if y>ymax:ymax=y
     if y<ymin:ymin=y
  xbredde=xmax-xmin
  ybredde=ymax-ymin
  width=0.1
  qdba={}
  for i in range(len(lst)):
     x=lst[i][0]
     y=lst[i][1]
     Ix=int((x-xmin)/width)
     Iy=int((y-ymin)/width)
     if not qdba.has_key(Ix):
        qdba[Ix]={}
        qdba[Ix][Iy]=[i]
     else:
        if not qdba[Ix].has_key(Iy):
           qdba[Ix][Iy]=[i]
        else:
           qdba[Ix][Iy].append(i)
  return qdba,(xmin,ymin,width)

def sizedContainer(k,ivlstlst,cont,init):
     if k==0:return cont[vlstilst[0]]
     elif k==len(ilst) and init==1:return cont[ilst[k]]
     else: return sizedContainer(self,k+1,ilst,cont[ilst[0]],1)

def weightedSumRMSDs(D):
    Dsum2=0
    for n in range(2):
        Dn=D[n]**2
        if len(Dn)>0:Dsum2=Dsum2+sum(Dn)/len(Dn)
        else:pass
        ##    Dn=D[1-n]**2
	##    Dsum2=Dsum2+sum(Dn)/len(Dn)
	##    Dsum2=Dsum2+0.2**2
    if VERBOSE:print sqrt(Dsum2)
    return sqrt(Dsum2)

def SumMaxs(D):
    Dsum2=0
    for n in range(2):
        Dn=D[n]**2
        Dsum2=Dsum2+max(Dn)
    ##print sqrt(Dsum2)
    return sqrt(Dsum2)

class VoxelContainer:
  def __init__(self):
     self.container={}
     ##self.dimension=2
     self.dimension=1
     self.fullwidth=[]
     self.vwidth=[]
     ##self.min=[9999999,999999]
     ##self.max=[-9999999,-999999]
     self.min=[999999]
     self.max=[-999999]
     self.numdata=0
     self.list=[]
     self.vallst=[]
 
  def getCopy(self,vwidth=None):
     print vwidth
     vc=VoxelContainer()
     if vwidth==None:vc.vwidth=self.vwidth
     else:vc.vwidth=vwidth
     vc.fillContainer(self.list)
     return vc

  def fillContainer(self,lst,tag=None):
   if len(lst)==0:pass#print lst[:3]
   else:
     ##print lst[:2]
     #initialize variables
     if self.list==[]:self.list=lst     
     else:self.list=vstack((self.list,lst))
     self.numdata=len(lst)
     olddim=self.dimension
     newdim=len(lst[0])
     self.dimension=newdim
     scale=int(pow(self.numdata,1.0/self.dimension))
     for i in range(newdim-olddim):
	self.min.append(self.min[0])
	self.max.append(self.max[0])
     for i in range(len(lst)):
	for j in range(newdim):
	   if lst[i][j]>self.max[j]:self.max[j]=lst[i][j]
	   if lst[i][j]<self.min[j]:self.min[j]=lst[i][j]#;print j,lst[i][j]
     for j in range(newdim):
	self.fullwidth.append(self.max[j]-self.min[j])
     if len(self.vwidth)==0 or self.vwidth==None:
       print self.vwidth
       print 'WARNING:vwidth not initialized - could be a spelling mistake?'
       for j in range(newdim):
	self.vwidth.append((self.max[j]-self.min[j])/scale)
     #now start filling in multidimensional data
     #hvad skal der ske hvis container er fyldt foer?
     ##print self.dimension
     ##print self.vwidth
     ##print self.fullwidth
     for i in range(self.numdata):
	ilst=[]
	for j in range(self.dimension):
	   ilst.append(0)
	for j in range(self.dimension):
	   #print i,j,lst[i][j]
	   #print i,j,self.vwidth
	   ind=int((lst[i][j]-self.min[j])/self.vwidth[j])
	   ilst[j]=ind
	key=tuple(ilst)
        if not self.container.has_key(key):
	   if tag==None: self.container[key]=[i]
	   else: self.container[key]=[(i,tag)]
        else:
	   if tag==None:self.container[key].append(i)	
	   else:self.container[key].append((i,tag))	
  
  def putSlices(self,vwidth=None,comp=0):
       lst=array(self.list)
       vclst=[]
       for i in range(self.dimension):
           vc=VoxelContainer()
	   if vwidth<>None:vc.vwidth=vwidth*ones(1)
           else:vc.vwidth=self.vwidth
           listi=lst[:,[i]]
           listc=lst[:,range(i)+range(i+1,self.dimension)]
	   if comp==0:
		vc.fillContainer(listi)
                vc.vallst2=listc
	   elif comp==1:
		vc.fillContainer(listc)
                vc.vallst2=listi
           ##print listi[0:3]
           ##print vc.list[0:3]
           vc.vallst=self.vallst
           vclst.append(vc)
       self.slices=vclst

  def getRawPeaks(self,val,dist,met,S,axis=0):
        dlst=self.slices[axis].findNearestFromCoord([val],met,S,maxd=dist)
        ##print dlst[:3],len(dlst)
        coslst=[];hilst=[];poslst=[]
        for x in dlst:
            coslst.append(self.slices[axis].vallst2[x[2]])
            hilst.append(self.slices[axis].vallst[x[2]])
            poslst.append(x[0])
        return array(coslst),array(hilst),array(poslst)

  def findNearestPair(self,met,S):
      mind=99999999
      pair=(None,None)
      for i in range(len(self.list)):
          nnlst=self.findNearestNeighbours(i)
          for ni in nnlst:
             if ni>i:
                newelem=self.list[ni]
                d=met(self.list[i],newelem,S)
                ##print i,ni,d
                if d<mind:mind=d;pair=(i,ni)
      return pair[0],pair[1],mind
              
  def findNearestNeighbours(self,i):
     ilst=[]
     for j in range(self.dimension):ilst.append(0)
     elem=self.list[i]
     nnlst=[]
     milst=[]
     for j in range(self.dimension):
           num=(elem[j]-self.min[j])/self.vwidth[j]
	   ind=int(num)
	   #rest=(num-ind)/self.vwidth[j]
	   rest=num-ind
           ilst[j]=ind
	   if rest<0.5:
		if ind-1>=0:silst=[ind,ind-1]
		else:silst=[ind]
	   else:
		silst=[ind,ind+1]
           milst.append(silst)
     for inds in comb(milst):
        key=tuple(inds)
	if self.container.has_key(key):
	   vlst=self.container[key]
           nnlst=nnlst+vlst
     return nnlst

  def findNearestFromCoord(self,elem,met,s,numb=1,list='no',maxd=None,doSort=True):
     if len(self.list)==0:
	if list=='y':return []
	else:return [[None,None,None]]
     ilst=[]
     for j in range(self.dimension):ilst.append(0)
     nnlst=[]
     milst=[]
     ##print 'len:',len(elem)
     for j in range(self.dimension):
           ##print elem,self.min,self.vwidth,j
           num=(elem[j]-self.min[j])/self.vwidth[j]
	   ind=int(num)
	   rest=num-ind
           ilst[j]=ind
	   if rest<0.5:
		if ind-1>=0:silst=[ind,ind-1]
		else:silst=[ind]
		##silst=[ind,ind-1]
	   else:
		silst=[ind,ind+1]
           milst.append(silst)
     if self.dimension>1:searchlist=comb(milst)
     else:
	searchlist=[]
	for i in range(len(milst[0])):
	   searchlist.append([milst[0][i]])
     for inds in searchlist:
        key=tuple(inds)
	##print 'key:',key
	if self.container.has_key(key):
	   vlst=self.container[key]
           nnlst=nnlst+vlst
     if list=='y':return nnlst
     dlst=[]
     ##print nnlst
     for ni in nnlst:
       newelem=self.list[ni]
       d=met(elem,newelem,s)
       ##if d<=maxd:
       if d<=maxd or maxd==None:#IMPORTANT CHANGE!!!
        dlst.append((d,newelem,ni))
     ##print dlst,numb
     ##print len(dlst)
     ##if len(dlst)>0:print dlst[0]
     ##if len(dlst)>1:print dlst[:2]
     try:
	if doSort:dlst.sort()
     except ValueError:print 'WARNING: dlst might not be sorted...'
     if maxd<>None:
        for i in range(len(dlst)):
            if dlst[i][0]>maxd: return dlst[:i]
            elif i==len(dlst)-1:return dlst
            ##print '***',i,dlst[i][0]
     ##print dlst,numb
     if numb==None:return dlst
     return dlst[:numb]

  def getClosePairs(self,met,s,maxd):
     closePairlst=[]
     for i in range(len(self.list)):
	nnlst=self.findNearestNeighbours(i)
	dlst=[]
        for ni in nnlst:
	 if ni<>i:
           newelem=self.list[ni]
           d=met(self.list[i],newelem,s)
           dlst.append((d,newelem,ni))
        dlst.sort()
	if len(dlst)>0:
         if dlst[0][0]<maxd:
	   closePairlst.append((i,dlst[0][2],dlst[0][0]))
	   ##print self.list[i],self.list[dlst[0][2]]
     return closePairlst

  def divide(self,choose=allwaysTrue,vwidth=None,doarray=0):
    mat=[]
    valmat=[]
    for i in range(self.partition.numParts):
	mat.append([])
	valmat.append([])
    f=self.partition.classifyer
    r=self.partition.repr
    for i in range(len(self.list)):
      v=self.list[i]
      if choose(v):
        if doarray:v=array(v)
	mat[f(v)].append(r(v))
	valmat[f(v)].append(i)
    vclst=[]
    ##print len(mat[0]),len(mat[1])
    for n in range(len(mat)):
	if VERBOSE:print len(mat[i]),
    for i in range(len(mat)):
	vc=VoxelContainer()
	if vwidth==None:vc.vwidth=self.vwidth
	else:vc.vwidth=vwidth
	vc.fillContainer(mat[i])
	vclst.append(vc)
	vc.partition=self.partition
	vc.vallst=valmat[i]
	print len(vc.list),
	print
    self.vcs=vclst

def getClusters1d(vc,distMetric,S,refd):
      cc=ClusterContainer()
      for i in range(len(vc.list)):
        p=vc.list[i]
        dlst=vc.findNearestFromCoord(p,distMetric,S,maxd=refd)
	##if len(dlst)>0:print p,len(nnlst)
	for j in range(len(dlst)):	
          d,pi,ni=dlst[j]
	  ##print d,i,ni
	  if i<>ni:
		cc.pair(i,ni)
		##print 'pairing', i, ni
          ##print '----------'
      for ck in cc.c2i.keys():
        if VERBOSE:print ck,cc.c2i[ck]
      cc.vc=vc
      return cc

def getClusters(vc,distMetric,S,refd,useis=None):
      cc=ClusterContainer()
      for i in range(len(vc.list)):
        if useis==None or i in useis:
          p=vc.list[i]
          nnlst=vc.findNearestNeighbours(i)
	  ##if len(nnlst)>0:print p,len(nnlst)
          for ni in nnlst:
           if ni<>i and (useis==None or ni in useis):
            np=vc.list[ni]
            d=distMetric(p,np,S)
	    ##print d,i,ni
            if d<refd:
		cc.pair(i,ni)
		##print 'pairing', i, ni
          ##print '----------'
      ##for ck in cc.c2i.keys():
      ##  print ck,cc.c2i[ck]
      cc.vc=vc
      return cc

def getClusters2(vcs,distMetric,S,refd,useis=None,sym=0,tag=None,Index0=0,cc=None):
      if cc==None: cc=ClusterContainer(Index=Index0)
      if VERBOSE:print useis
      if VERBOSE:print 'vclens:',
      nump=vcs[0].partition.numParts
      for i in range(nump):
	print len(vcs[i].list),
      if VERBOSE:print
      r=vcs[0].partition.repr
      ##for pair in vcs[0].partition.comblst:
      for I in range(nump):
       for i in range(len(vcs[I].list)):
        if useis==None or i in useis[I]:
         paired=0
         for J in range(I+1,nump):
	  ##print 'I er nu:',I
          ##p=vcs[0].list[i]
          ##if sym==1:p=take(p,[1,0])
          ##print p
          p=vcs[I].list[i]
          nnlst=vcs[J].findNearestFromCoord(p,distMetric,S,list='y')
          ##print i,nnlst
          for ni in nnlst:
           if useis==None or ni in useis[J]:
            np=vcs[J].list[ni]
            d=distMetric(p,np,S)
	    ##print p,np,d,I,J
            if d<refd:
                cc.pair(i,ni,tag=tag,sym=[I,J])
		paired=1
		if VERBOSE:print 'PAIRING',I,J,i,ni
                ##print d,p,np
          ##print '----------'
	  if not paired:
	      #TODO:goer faerdigt!!!!!!!!!!
	      #skal paired vaere array
	      #skal paired vaere array?
              if VERBOSE:print 'SINGLE:',i,I
              cc.appendSingleCluster(i,tag=tag,side=I)
      for J in range(1,nump):
       for j in range(len(vcs[J].list)):#tjek om alle har en nabo
	if useis==None or j in useis[J]:
	  ##print j,vcs[J].list[j]
          if tag<>None:
              if sym<>0:
                  i=(j,tag,J)
              else:
                  i=(j,tag)
          else:i=j
          if not cc.i2c.has_key(i):
              if VERBOSE:print 'NOKEY:',i
              cc.appendSingleCluster(j,tag=tag,side=J)
      ##for ck in cc.c2i.keys():
      ##  print ck,cc.c2i[ck]
      cc.vcs=vcs
      cc.useis=useis
      return cc

def findnn(data,coords):
  nn=[]
 # qdba,qbounds=data[1],data[2]
  xdisp=(coords[0]-qbounds[0])/qbounds[2]
  ydisp=(coords[1]-qbounds[1])/qbounds[2]
  xint=int(xdisp)
  yint=int(ydisp)
  nn.append((xint,yint))
  if xdisp-xint<0.5:
     xnn=xint-1
  else:
     xnn=xint+1
  if ydisp-yint<0.5:
     ynn=yint-1
  else:
     ynn=yint+1
  nn.append((xnn,yint))
  nn.append((xint,ynn))
  nn.append((xnn,ynn))
  nnlst=[]
  for nnelem in nn:
     try:
        qlst=qdba[nnelem[0]][nnelem[1]]
        nnlst=nnlst+qlst
     except KeyError: pass
  return nnlst

def testVoxelContainer():
  spectrum3d=VoxelContainer()
  mat0=array([[10.0,0.0,-10.0],[-5.0,-1.0,15.0],[20.0,2.0,-13.0],[9.0,-8.0,-4.0]])
  mat1=vstack((mat0,mat0*2,-mat0**2))
  mat2=vstack((mat1,mat1*2,-0.1*mat0**2))
  mat=vstack((mat2,-mat1*0.5))
  #mat=[[10.0,0.0,-10.0],[-5.0,-1.0,15.0]]
  print mat
  spectrum3d.vwidth=[15.0,15.0,15.0]
  spectrum3d.fillContainer(mat)
  print spectrum3d.list
  print spectrum3d.container
  print spectrum3d.findNearestNeighbour(0)

class ClusterContainer:
   def __init__(self,Index=0):
      self.c2i={}
      self.i2c={}
      self.index=Index#first cluster index to be used
      self.vc=None

   def combine(self,i,j,itype=0):
      ##print 'combine',i,j
      if itype==0:
          ci=self.i2c[i]
          cj=self.i2c[j]
      else:ci=i;cj=j
      ##print ci,cj,self.index
      self.c2i[self.index]=self.c2i[ci]+self.c2i[cj]
      del self.c2i[ci]
      del self.c2i[cj]
      for k in self.c2i[self.index]:
	  self.i2c[k]=self.index
      self.index=self.index+1

   def cappend(self,i,j):
      ci=self.i2c[i]
      self.c2i[ci].append(j)
      self.i2c[j]=ci

   def cremove(self,ci,j):
      self.c2i[ci].remove(j)
      del self.i2c[j]
      #eller self.i2c[j]=None?

   def appendSingleCluster(self,I,tag=None,side=0):
      if tag<>None:
          i=(I,tag,side)
      else:i=I
      if not self.i2c.has_key(i):
	self.i2c[i]=self.index
	self.c2i[self.index]=[i]
	self.index=self.index+1    

   def appendClusters(self,cclst,overwrite=[1,1]):
     self.cclst=cclst
     for i in range(len(cclst)):
       cc=cclst[i]
       for c in cc.c2i.keys():
           if (not self.c2i.has_key(c)) or overwrite[0]:
               self.c2i[c]=cc.c2i[c]
           else:pass#TODO: what?
       for i in cc.i2c.keys():
           if (not self.i2c.has_key(i)) or overwrite[1]:
               self.i2c[i]=cc.i2c[i]
           else:pass#TODO: what?

   def pair(self,I,J,tag=None,sym=0):
      if tag<>None:
          if sym<>0:
              i=(I,tag,sym[0])
              j=(J,tag,sym[1])
          else:
              i=(I,tag)
              j=(J,tag)
      else:i=I;j=J
      if VERBOSE:print 'now pairing:',i,j
      ##print self.index,self.i2c.keys(),self.c2i.keys()
      if not (i in self.i2c.keys() or j in self.i2c.keys()):
        self.i2c[i]=self.index
        self.i2c[j]=self.index
        self.c2i[self.index]=[i,j]
        self.index=self.index+1
        #print 'index updated:',self.index
      elif i in self.i2c.keys() and j in self.i2c.keys():
        if self.i2c[i]==self.i2c[j]:pass #trivielt tilfaellde
        else:self.combine(i,j)#kritisk tilfaelde 2 clustre skal kombineres - proev senere med trae-struktur
      elif i in self.i2c.keys():
        #j not in self.i2c.keys()
        self.cappend(i,j)
      else:self.cappend(j,i)
   
   def strip(self,ck,refd,met,S,removed=[]):
      if len(self.c2i[ck])<=2:return removed
      sa=zeros(len(self.c2i[ck]))*0.0
      for I in range(len(self.c2i[ck])):
          i=self.c2i[ck][I]
          dlst=[]
          for j in self.c2i[ck]:
              d=met(self.vc.list[i],self.vc.list[j],S)
              ##if d>refd:print i,j,d
              dlst.append(d)
          da=array(dlst)
          ##print i,sum(da),max(da)
          if max(da)>refd:sa[I]=sum(da)
      msa=max(sa)
      amsa=argmax(sa)
      ##print msa,amsa
      if msa<=refd:
          ##print 'final',removed
          return removed
      else:
          i=self.c2i[ck][amsa]
          removed.append(i)
          ##print 'i=',i,removed
          ##print self.vc.list[i]    
          self.cremove(ck,i)
          return self.strip(ck,refd,met,S,removed=removed[:])    
      
   def stripAll(self,refd,met,S):
      for k in self.c2i.keys():
        ##print '-------',k,'-------'
        rem=self.strip(k,refd,met,None)
        ##print rem
        if len(rem)>1:
            self.expand(rem,refd,met,None)
      
   def expand(self,ilst,refd,met,S):
       pcc2=getClusters(self.vc,met,S,refd,useis=ilst)
       for k in pcc2.c2i.keys():
           rem=pcc2.strip(k,refd,met,S,removed=[])
           ##print 'rem:',rem
           if len(rem)>1:
               pcc2.expand(rem,refd,met,S)
       for k in pcc2.c2i.keys():
           selfk=0
           while True:
               if not selfk in self.c2i.keys():
                   self.c2i[selfk]=pcc2.c2i[k][:]
                   for i in pcc2.c2i[k]:
                       self.i2c[i]=selfk
                   break
               else:selfk=selfk+1
               
   def appendSingles(self):
      for i in range(len(self.vc.list)):
	if not i in self.i2c.keys():
	   if VERBOSE:print 'appending:',i
	   self.appendSingleCluster(i)

   def getCharacteristics(self,met,S):
      res=[]
      for c in self.c2i.keys():
       inds=self.c2i[c]
       if len(inds)==1:
	co=self.vc.list[inds[0]]
	res.append((co,None,None,None,co[0],co[0],0,0,1))
       else:
	##print inds
	maxd=0
	maxi=None;mini=None
	sumd=0.0
	sumd2=0.0
	sumc=zeros(self.vc.dimension)
	sumc2=zeros(self.vc.dimension)
	li=len(inds)
	maxc=-9999999
	minc=9999999
	for i in inds:
	    coi=array(self.vc.list[i])#farligt for andre programmer?!!!
	    sumc += coi
	    sumc2+=(coi**2)
	    if self.vc.dimension==1:#eller hvis man kan definere en ordning
		if coi[0]>maxc:maxc=coi[0];maxi=i
		if coi[0]<minc:minc=coi[0];mini=i
	    for j in inds:
	      if j<i:
		d=met(self.vc.list[i],self.vc.list[j],S)
		if d>maxd:maxd=d
		sumd=sumd+d
		sumd2=sumd2+d**2
	##stdc=math.sqrt(sumc2/li-((sumc/li)**2))
	stdc=sqrt(sumc2/li-((sumc/li)**2))
	res.append((sumc/li,sumd/(li**2-li),sqrt(sumd2/(li**2-li)),maxd,minc,maxc,mini,maxi,stdc,li))
	#TODO tjek om det skal vaere .......sqrt(sumd2/(0.5*li**2-li))...............
      self.char=res
      return res

   def getMeanStd(self):
       return numpy.average(self.vc.list,axis=0),\
              numpy.std(self.vc.list,axis=0)

   def getRepresentative(self,frac=0.1,default=10.0):
       maxnum=1;maxval=None
       for tup in self.char:
	   if tup[-1]>maxnum:
		maxnum=tup[-1]
		maxval=tup
       return maxval[0],maxval[-2],maxval[-1]
       li=maxnum
       if li==1:return tup[0],default
       elif li<4:
           return tup[0],maxval[2]
       else:
           return tup[0],sqrt((li-1.0)/(li-3.0)/li*(maxval[2]**2))

   def getAggregates(self,vc,met,S,refd):
       cc=ClusterContainer()
       keys=self.c2i.keys()
       for k in range(len(self.c2i.keys())):
           cc.c2i[keys[k]]=[]
       for i in range(len(vc.list)):
           dMin=999999999;dMink=None
           for k in range(len(self.c2i.keys())):
               p=vc.list[i]
               dmin=met(p,self.char[k][4],S)
               dmax=met(p,self.char[k][5],S)
               d=min(dmin,dmax)
               if d<dMin:dMin=d;dMink=k
               ##print d,
               ##print i,dMin,dMink
           if dMin<refd:
               ##print dMin,dMink
               cc.c2i[keys[dMink]].append(i)
       return cc

class SuperClusterContainer(ClusterContainer):
   cclst=None##list of clusters
   countmap=None##map translate indexes in cclst to mnum

   def combpair(self,i,j):#i=(*,*)
      #print self.index,self.i2c.keys(),self.c2i.keys()
      ##key=(min(i,j),max(i,j)) 
      if not (i in self.i2c.keys() or j in self.i2c.keys()):
        self.i2c[i]=self.index
        self.i2c[j]=self.index
        self.c2i[self.index]=[i,j]
        self.index=self.index+1
        #print 'index updated:',self.index
      elif i in self.i2c.keys() and j in self.i2c.keys():
        if self.i2c[i]==self.i2c[j]:pass #trivielt tilfaellde
        else:self.combine(i,j)
	#kritisk tilfaelde 2 clustre skal kombineres - proev senere med trae-struktur
      elif i in self.i2c.keys():
        #j not in self.i2c.keys()
        self.cappend(i,j)
      else:self.cappend(j,i)

   def getElems(self,k):
	  if VERBOSE:print 'getting elements'
          ilst=self.c2i[k]
          ilst=array(ilst)
          if VERBOSE:print ilst
          xlst=[]
          for j in range(len(ilst)):
              ij=ilst[j]
              num=ij[0]
              ccnum=num#TODO: TJEK: kan det give problemer? - ser ud til at vaere OK!
              cc=self.cclst[ccnum]
              lst=cc.c2i[ij[1]]
              if VERBOSE:print lst
	      ##print 'ENS?:',num,
	      ##for i in range(len(lst)):print lst[i][1],
	      ##print
	      xlst.append(lst)
          return xlst

   def scremove(self,k,j,x):
       ##print 'scremove'
       ccnum,c=self.c2i[k][j]
       cc=self.cclst[ccnum]
       cc.cremove(c,x)
       ##print 'modified:', self.c2i[k][j],
       ij=self.c2i[k][j]
       num=ij[0]
       ccnum=num
       cc=self.cclst[ccnum]
       lst=cc.c2i[ij[1]]
       ##print lst
       ##if lst==[]:del self.c2i[k][j]#noedvendigt?
       ##print cc.c2i[c]
       ##print cc.i2c       

   def getMax(self,xlst,j,acountmat,met,S,violfunc=weightedSumRMSDs,side0=None):
      #har man brug for at sideo=None???
      lst=acountmat[j][side0]
      ##print lst
      if len(lst)==0:return 0,0
      da=zeros(len(lst))*0.0
      part=self.cclst[0].vcs[0].partition
      r=part.repr
      for m in range(len(lst)):
	p=lst[m]
	thisj,thisi=p
	x=xlst[thisj][thisi]
        dmat=[[],[]]
        ##print x
        side=x[2]
        ##pk=self.cclst[x[1]].vcs[side].list[x[0]]
        pk=r(self.cclst[x[1]].vcs[side].list[x[0]])
	##print pk
	slst=range(part.numParts)
	slst.remove(side)
	for otherside in slst:
         ##for pc in acountmat[j][1-side]:
         for pc in acountmat[j][otherside]:
	   thisjc,thisic=pc
	   y=xlst[thisjc][thisic]
           ##print x,y
           pky=self.cclst[y[1]].vcs[otherside].list[y[0]]#TODO:TJEK: er y[1] OK som index?
           ##pky=take(pky,[1,0])
           pky=r(pky)
           d=met(pk,pky,S)
           ##print d,pc
           dmat[0].append(d)
        searchlst=range(len(xlst))
        searchlst.remove(thisj)
        for sj in searchlst:
           lst1=xlst[sj]
           for y1 in lst1:
                side1=y1[2]
                if side1==side:
                    pk1=self.cclst[y1[1]].vcs[side].list[y1[0]]
		    #unoedvendigt at bruge r() da pk og pk1 er paa samme "side"
                    d=met(pk,pk1,S)
                    dmat[1].append(d)
                    ##print pk,pk1,j,sj,i
        D=array(dmat[0]),array(dmat[1])
        viol=weightedSumRMSDs(D)
        da[m]=viol
       ##else:da[i]=0.0
      mda=max(da)
      amda=argmax(da)
      ##print 'sdfsdfsdf',j,mda,amda
      return mda,amda

   def strip2(self,xlst,k,refd,met,S,removed=[]):
      if VERBOSE:print 'vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv'
      if VERBOSE:print xlst
      sa=[]
      for j in range(len(xlst)):sa.append([0.0,0.0])
      acountmat=[]
      for i in range(len(self.cclst)):
	A=[]
	for i in range(self.cclst[0].vcs[0].partition.numParts):
	  A.append([])
	acountmat.append(A)
	##acountmat.append(([],[]))
      for j in range(len(xlst)):
          if VERBOSE:print '***********',j
          lst=xlst[j]
          if VERBOSE:print lst
          if VERBOSE:print k,j
	  count=[]
	  for i in range(self.cclst[0].vcs[0].partition.numParts):
	    count.append([])
          ##count=[[],[]]
          for i in range(len(lst)):
            x=lst[i]
            side=x[2]
	    num=x[1]
	    acountmat[num][side].append((j,i))
      if VERBOSE:print 'acountmat',acountmat
      for i in range(len(self.cclst)):
	for n in range(self.cclst[0].vcs[0].partition.numParts):
	##for n in range(2):
	  if len(acountmat[i][n])>1:
	      if VERBOSE:print 'acountmat[i][n]:',acountmat[i][n]
              mda,amda=self.getMax(xlst,i,acountmat,met,S,side0=n)
	      p=acountmat[i][n][amda]
	      thisj,thisi=p
              sa[thisj][0]=mda
              sa[thisj][1]=thisi
      ##print 'sa',sa,sa[3],sa[3][0]
      sa=array(sa)
      msa=max(sa[:,0])
      amsa=argmax(sa[:,0])
      snum=int(sa[amsa][1])
      ##print 'msa,amsa:',msa,amsa,snum,
      if msa>0.0:
          ys=xlst[amsa][snum]
          if VERBOSE:print 'removed:',ys,
          if VERBOSE:print self.cclst[ys[1]].vcs[ys[2]].list[ys[0]]
          removed.append((amsa,ys))#amsa "mixtidnum" i omvendt raekkefoelge
          if VERBOSE:print removed
          self.scremove(k,amsa,ys)
          #nu skal xlst initialiseres igen!!!...
          #det ser ud til at scrremove har effekt paa xlst via koblede lister!!!
          return self.strip2(xlst,k,refd,met,S,removed=removed[:])
      else:
          if VERBOSE:print 'nu skal der tjekkes om den globale RMSD er OK...'
	  if VERBOSE:print xlst
          ##for j in range(len(xlst)):
          for i in range(len(self.cclst)):
              ##mda,amda=self.getMax(xlst,j,countmat[j],met,S,violfunc=SumMaxs)
	    ##for n in range(2):
	    for n in range(self.cclst[0].vcs[0].partition.numParts):
	     if len(acountmat[i][n])>0:
              mda,amda=self.getMax(xlst,i,acountmat,met,S,violfunc=SumMaxs,side0=n)
	      ##print mda,amda
	      p=acountmat[i][n][amda]
	      ##print p
	      thisj,thisi=p
	      if mda>sa[thisj][0]:
		sa[thisj][0]=mda
		sa[thisj][1]=thisi
          sa=array(sa)
          msa=max(sa[:,0])
          amsa=argmax(sa[:,0])
          snum=int(sa[amsa][1])
          ##print 'msa,amsa:',msa,amsa,snum,
	  if msa>0.0:
           ys=xlst[amsa][snum]
           ##print ys,
           if VERBOSE:print self.cclst[ys[1]].vcs[ys[2]].list[ys[0]]
          if msa>refd:
              removed.append((amsa,ys))#amsa "mixtidnum" i omvendt raekkefoelge
              if VERBOSE:print removed
              self.scremove(k,amsa,ys)
              ##del self.c2i[k][amsa]# har ingen effekt
              #det ser ud til at scremove har effekt paa xlst via koblede lister!!!
              return self.strip2(xlst,k,refd,met,S,removed=removed[:])
          else: return removed
            
   def stripAll2(self,refd,met,S):#strip a SuperClusterContainer from a build-up
##      newsccs=[]
      for k in self.c2i.keys():
        if VERBOSE:print '-------',k,'-------'
	xlst=self.getElems(k)
	rem=self.strip2(xlst,k,refd,met,S,removed=[])
        if VERBOSE:print 'REMOVED',rem
        if len(rem)>0:
            self.expand2(rem,refd,met,None)
##            newscc=self.expand2(rem,refd,met,None)
##	    newsccs.append(newscc)
##      return newsccs

   def expand2(self,ilst,refd,met,S):
     ##cclst=[]
     countmap={}
     part=self.cclst[0].vcs[0].partition
     r=part.repr
     pnum=part.numParts
     ##ilst.sort()
     startIndexlst=[]
     for k in range(len(ilst)):
	j,i=ilst[k]
	I,mnum,side=i
	##if not countmap.has_key(mnum):countmap[mnum]=[[],[],[]]
	if not countmap.has_key(mnum):
	    countmap[mnum]=[]
	    for i in range(pnum):
		countmap[mnum].append([])
	countmap[mnum][side].append(I)
	##countmap[mnum][2].append(k)
     keys=countmap.keys()
     keys.sort()
     ##for k in range(len(keys)):
     for mnum in range(len(self.cclst)):
	startIndexlst.append(self.cclst[mnum].index)
        if not countmap.has_key(mnum):
            ##cclst.append(None)
            if VERBOSE:print 'no mixing time num:',mnum
        else:
            cm=countmap[mnum]
            ##print cm
            cc=self.cclst[mnum]
	    if VERBOSE:print 'before:',cc.c2i
            pcc2=getClusters2(cc.vcs,met,S,refd,useis=cm,tag=mnum,sym=1,cc=cc)
	    if VERBOSE:print 'after:',cc.c2i
            #tag<>mnum???
            ##cclst.append(pcc2)
            if VERBOSE:print '_:_:_:_:_'
            ##print pcc2.c2i
            ##print pcc2.i2c
     ##ccc=combineClusters(self.cclst,met,S,refd,usemap=countmap)
     if VERBOSE:print startIndexlst
     if VERBOSE:print 'Before:',self.c2i
     ccc=combineClusters(self.cclst,met,S,refd,scc=self,stilst=startIndexlst)
     if VERBOSE:print 'After:',self.c2i
     ##ccc.countmap=countmap
     if VERBOSE:print ccc.i2c,'huhuhuh'
     if VERBOSE:print ccc.c2i
     ##self.unify(ccc)
     ##print 'done unifying'
     ##xlst=self.getElems(4)
      
   def expand2_old(self,ilst,refd,met,S):
     cclst=[]
     countmap={}
     ##ilst.sort()
     for k in range(len(ilst)):
	j,i=ilst[k]
	I,mnum,side=i
	##if not countmap.has_key(mnum):countmap[mnum]=[[],[],[]]
	if not countmap.has_key(mnum):countmap[mnum]=[[],[]]
	countmap[mnum][side].append(I)
	##countmap[mnum][2].append(k)
     keys=countmap.keys()
     keys.sort()
     for k in range(len(keys)):
	mnum=keys[k]
	cm=countmap[mnum]
	if VERBOSE:print cm
	cc=self.cclst[mnum]
	##print cc.vcs[side].list[I]
	##pcc2=getClusters2(cc.vcs,met,S,refd,useis=cm,tag=k,sym=1)
	pcc2=getClusters2(cc.vcs,met,S,refd,useis=cm,tag=mnum,sym=1)
	#tag<>mnum???
	cclst.append(pcc2)
        if VERBOSE:print '_:_:_:_:_'
        if VERBOSE:print pcc2.c2i
        if VERBOSE:print pcc2.i2c
     ccc=combineClusters(cclst,met,S,refd)
     ccc.countmap=countmap
     if VERBOSE:print ccc.i2c,'huhuhuh'
     if VERBOSE:print ccc.c2i

     if 0:#TODO: goer faerdig...  for k in pcc2.c2i.keys():
           rem=pcc2.strip(k,refd,met,S,removed=[])
           ##print 'rem:',rem
           if len(rem)>1:
               pcc2.expand2(rem,refd,met,S)
     if 0:#TODO: goer faerdig...  for k in pcc2.c2i.keys():
           selfk=0
           while True:
               if not selfk in self.c2i.keys():
                   self.c2i[selfk]=pcc2.c2i[k][:]
                   for i in pcc2.c2i[k]:
                       self.i2c[i]=selfk
                   break
               else:selfk=selfk+1
     return ccc

   def unify(self,scc):#antager at parrent vcs er identiske for self og scc (elementer i cclst)
       if VERBOSE:print 'UNIFYING...'
       for k in self.c2i.keys():
           ilst=self.c2i[k]
           if VERBOSE:print k,ilst
       xlst=self.getElems(2)
       if VERBOSE:print self.index
       if VERBOSE:print '__________________'
       if VERBOSE:print scc.countmap
       xlst=scc.getElems(0)
       for k in scc.c2i.keys():
           ilst=scc.c2i[k]
           if VERBOSE:print k,ilst
           for ij in ilst:
               num=ij[0]
               ccnum=num
               cc=self.cclst[ccnum]
               newcc=scc.cclst[ccnum]
               lst=cc.c2i[ij[1]]
               newlst=newcc.c2i[ij[1]]
               if VERBOSE:print 'oldlst,newlst:',lst,newlst
               #now do the unifying stuff...
               for y in newlst:lst.append(y)
           self.c2i[self.index]=ilst
           for inds in ilst:self.i2c[inds]=self.index
           self.index=self.index+1

   def getCharacteristics(self,met,S):
      res=[]
      part=self.cclst[0].vcs[0].partition
      r=part.repr
      pnum=part.numParts
      Dim=self.cclst[0].vcs[0].dimension
      count=0
      sumViol=0.0
      lowest=[]
      maxmnums=len(self.cclst)
      numsides=len(self.cclst[0].vcs)
      maxli=maxmnums*numsides
      for c in self.c2i.keys():
        ##print '---------------------- characteristics:',c
        inds=self.c2i[c]
        sumlen=0
 	maxd=0
	maxi=[];mini=[]
	maxc=[];minc=[]
	for i in range(Dim):
	   maxi.append(None)
	   mini.append(None)
	   maxc.append(-99999999)
	   minc.append(99999999)
	sumd=0.0
	sumd2=0.0
	sumc=zeros(Dim)
	mnumdba={}
	for I in inds:
	    ccnum,cI=I
	    cci=self.cclst[ccnum]
	    lst=cci.c2i[cI]
	    if VERBOSE:print 'lst:',lst
	    for x in lst:
		count+=1
		i,mnum,side=x
		if not mnumdba.has_key(mnum):mnumdba[mnum]={}
		if not mnumdba[mnum].has_key(side):mnumdba[mnum][side]=[]
		mnumdba[mnum][side].append(i)
		pi=cci.vcs[side].list[i]
		##pi=r(pi)
		##if side==1:pi=take(pi,[1,0])
		if VERBOSE:print pi,
		if VERBOSE:print
		sumc=sumc+pi
		sumlen=sumlen+1
		##print len(sumc),cci.vcs[side].dimension,minc,maxc,mini,maxi
		for n in range(Dim):
		    if pi[n]<minc[n]:minc[n]=pi[n];mini[n]=x
		    if pi[n]>maxc[n]:maxc[n]=pi[n];maxi[n]=x
	ave=sumc/sumlen
	if VERBOSE:print ave,'= average'
	if VERBOSE:print minc,'= minc'
	if VERBOSE:print maxc,'= maxc'
	li=sumlen

	for I in inds:
	    ccnum,cI=I
	    cci=self.cclst[ccnum]
	    lst=cci.c2i[cI]
	    for x in lst:
		i,mnum,side=x
		pi=cci.vcs[side].list[i]
		##if side==1:pi=take(pi,[1,0])
		pi=r(pi)
		d=met(ave,pi,S)
		if d>maxd:maxd=d
		sumd=sumd+d
		sumd2=sumd2+d**2
        if li>0:
            res.append((ave,sumd/li,sqrt(sumd2/li),maxd,minc,maxc,mini,maxi,li,mnumdba))
	    #VIGTIGT:der maa ikke aendres paa raekkefoelgen af elementerne i res[i]
	    if VERBOSE:print 'CHAR:',c,ave,sumd/li,sqrt(sumd2/li),maxd,minc,maxc,mini,maxi,li
	    ##if li>1:sumViol=sumViol+sqrt(sumd2/li)
	    if li>3:sumViol=sumViol+sqrt((li-1.0)/(li-3.0)/li*sumd2)
	    elif li>1:sumViol=sumViol+sqrt(sumd2)
	    else:sumViol=sumViol+0.3
	    if len(mnumdba.keys())==maxmnums and li>=maxli*0.5:
		lowest.append(sumd/li/li*maxli)
        else:
            res.append((ave,None,None,maxd,minc,maxc,mini,maxi,li,{}))
	    if VERBOSE:print 'CHAR:',c,ave,None,None,maxd,minc,maxc,mini,maxi,li
	    sumViol=sumViol+0.3
      self.char=res
      lowest.sort()
      sumlow=0.0
      for i in range(8):
	if len(lowest)>i:
	  sumlow=sumlow+lowest[i]
	else:
	  sumlow=sumlow+0.5
      print
      ##print 'TWO scores:',(sumViol/count-0.1)*10,sumlow/8-0.3
      ##self.score=((sumViol/count-0.1)*10+sumlow/8-0.3)/2
      self.score=sumViol/count-0.1
      ##print 'SCORE:',self.score
      return res

   def mergeClusters(self,met,S,mdiff=0.30):
	#TODO: skal man tjekke om der kommer for mange peaks i hver partition?
        self.getCharacteristics(met,S)
        if VERBOSE:print 'merging clusters...'
        mlst=[]
	print 'total is now:',len(self.c2i.keys())
        for ch in self.char:
            mean=ch[0]
            ##print mean
            mlst.append(mean)
        self.meanvc=VoxelContainer()
        self.meanvc.vwidth=ones(len(mean))*2.01*mdiff
        self.meanvc.fillContainer(mlst)
	print 'total len of vc is now:',len(self.meanvc.list)
        ##print vc.list
        i,j,d=self.meanvc.findNearestPair(met,S)
        ##print 'nearest:',i,j,d
        if d<mdiff:
	    ##print 'Merging',i,j,vc.list[i],vc.list[j]
            keys=self.c2i.keys()
            #do the merging stuf...
            self.combine(keys[i],keys[j],itype=1)
            self.mergeClusters(met,S)
	##self.meanvc=vc

def combineClusters(cclst,distMetric,S,refd,usemap=None,scc=None,stilst=None):
    if scc==None:scc=SuperClusterContainer()
    scc.cclst=cclst
    if usemap<>None:
        if VERBOSE:print 'using only',usemap
    for i in range(len(cclst)-1,0,-1):#baglaens undtagen foerste
     if VERBOSE:print '----- cluster:',i
     if 1:#usemap==None or (i in usemap.keys() and i-1 in usemap.keys()):
      cci=cclst[i];ccj=cclst[i-1]
      if cci<>None and ccj<>None:#NY betingelse
	vcsi=cci.vcs;vcsj=ccj.vcs
	for k in cci.c2i.keys():
	  if stilst==None or k>=stilst[i]:
	    for I in cci.c2i[k]:
	      cI,mnumi,sidei=I
	      if 1:#usemap==None or (cI in usemap[i][sidei]):
		pi=vcsi[sidei].list[cI]
		for m in ccj.c2i.keys():
	  	  if stilst==None or m>=stilst[i-1]:
	    	    for J in ccj.c2i[m]:
		      cJ,mnumj,sidej=J
                      if 1:#usemap==None or (cJ in usemap[i-1][sidej]):
			pj=vcsj[sidej].list[cJ]
			scale=1.0
			##pi=vcsi[0].partition.repr(pi)
			##pj=vcsi[0].partition.repr(pj)
			if sidej<>sidei:
			    ##pj=take(pj,[1,0])#mirror peak
			    scale=1.2#more restrictive pairing
			dij=distMetric(pi,pj,S)*scale
			if dij<refd:
			    ##print dij,pi,pj,'I',cI,mnumi,sidei,'J',cJ,mnumj,sidej
			    ##print 'pairing:',(i,k),'and',(i-1,m)
                            scc.pair((i,k),(i-1,m))#pair clusters in supercluster

    for i in range(len(cclst)):
     if 1:#usemap==None or (i in usemap.keys()):
      cci=cclst[i]
      if cci<>None:#NY betingelse
	if VERBOSE:print cci.i2c
	for k in cci.c2i.keys():
	  if stilst==None or k>=stilst[i]:
            ##print k,cci.c2i[k]
	    if not scc.i2c.has_key((i,k)):
		if VERBOSE:print 'appended:',i,k
		scc.appendSingleCluster((i,k))
    ##print scc.c2i
    ##print scc.i2c
    return scc

def getGroupings(A,d=10.0,met=distMetricTup,frac=0.1,numout=1):
    dat=zip(*A)
    vc=VoxelContainer()
    vc.vwidth=d*2.01*ones(len(A))
    vc.fillContainer(dat)
    cc=getClusters(vc,met,None,d)
    cc.appendSingles()
    ##print cc.c2i
    ##print cc.i2c
    cc.getCharacteristics(met,None)
    plotmat=[[],[],[]]
    num=0
    tot=zeros(len(A))
    for c in cc.char:
      for i in range(2):
	  plotmat[i].append(c[0][i])
      plotmat[2].append(c[-1])
      num+=c[-1]
      ##print c[0],c[-1]
      tot+=(c[0]*c[-1])
    mean,std,repnum=cc.getRepresentative()
    amean,astd=cc.getMeanStd()
    if (1.0*repnum)/len(dat)>frac and len(dat)-repnum>numout:
	mean=amean;std=astd
    ##print mean,amean,std,astd,tot/num
    return plotmat,mean,std

